function OW_NS.optionsinit()
  local OW_optionspanel = CreateFrame("Frame", "OWOptions")
  OW_optionspanel.name = "O-Wheely!"
	InterfaceOptions_AddCategory(OW_optionspanel)

  local scroll0 = CreateFrame('ScrollFrame',"obiscr0",OW_optionspanel,"UIPanelScrollFrameTemplate")
  scroll0:SetPoint("TOPLEFT",OW_optionspanel,"TOPLEFT",15,-15)
  --scroll0:SetPoint("TOPRIGHT",OW_optionspanel,"TOPRIGHT",-40,-15)
  scroll0:SetPoint("BOTTOMRIGHT",OW_optionspanel,"BOTTOMRIGHT",-30,70)
  --scroll0:SetHeight(300)
  local about = CreateFrame('SimpleHTML',"OWABout",scroll0)
  about:SetFontObject('P' ,GameFontHighlightSmall)
  about:SetFontObject('H1',GameFontHighlightLarge)
  about:SetFontObject('H2',GameFontHighlight)
  --about:SetPoint("TOPLEFT",OW_optionspanel,"TOPLEFT",15,-15)
  about:SetWidth(360)
  about:SetHeight(170)
  local text = OW_NS.abouttexttop
  if OW_NS.abouttextbuffs[OW_NS.class] then
  for bt,txt in pairs(OW_NS.abouttextbuffs[OW_NS.class]) do
    text = text .. "<BR/><H1>" .. OW_NS.abouttexttypes[bt] .. "</H1>" .. txt
  end
  end
  local sb,ssb = OW_NS.getsitubuffnames()
  if sb ~= "" or ssb ~= "" then
    text = text .. OW_NS.abouttextsitu
  end
  if ssb ~= "" then
    text = text .. OW_NS.abouttextsitu1 .. "<P>" .. ssb .. "</P>"
  end
  if sb ~= "" then
    text = text .. OW_NS.abouttextsitu2 .. "<P>" .. sb .. "</P>"
  end
  text = text .. OW_NS.abouttextend
  about:SetText(text)
  about:SetScript("OnHyperlinkClick",function() InterfaceOptionsFrameCancel_OnClick();InterfaceOptionsFrame_OpenToCategory(OW_NS.mwm) end)
  about:Show()
  scroll0:SetScrollChild(about)

  local function OW_mwupdnshow()
    if OW_combatspell then
      _G['owedup']:SetText(OW_combatspell)
    end
    if OW_combatspell2 then
      _G['oweddn']:SetText(OW_combatspell2)
    end
  end

  local OW_mwupdnpanel = CreateFrame("Frame", "OWMwUpDn")
  OW_mwupdnpanel.name = OW_NS.mwm
  OW_mwupdnpanel.parent = "O-Wheely!"
  OW_mwupdnpanel:SetScript("OnShow",OW_mwupdnshow)
	InterfaceOptions_AddCategory(OW_mwupdnpanel)
	
	OW_mwupdnpanel.okay = function() 
    local function blanktonil(val)
      if not val or strfind(val,"^ *$") then -- string is either "" or all spaces
        return ""
      else
        return val
      end
    end
    OW_combatspell = blanktonil(_G['owedup']:GetText()) 
    OW_combatspell2 = blanktonil(_G['oweddn']:GetText()) 
  end
	OW_mwupdnpanel.cancel = function() 
  end
  --Disabled because some addons call it randomly
	--OW_mwupdnpanel.default = function() 
  --  OW_combatspell = "" 
  --  OW_combatspell2 = "" 
  --end

	local function Dropdown_OnShow(self)
	  UIDropDownMenu_SetWidth(self, 180)
 		UIDropDownMenu_JustifyText(self, "LEFT")
		getglobal(self:GetName() .. 'Text'):SetText(" ")
		UIDropDownMenu_Initialize(self, self.Initialize)
	end
	local backdrop = {
		bgFile = "Interface\\ChatFrame\\ChatFrameBackground", insets = {left = 4, right = 4, top = 4, bottom = 4},
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16
	}

  local OW_updd = CreateFrame('Frame', "owcon0" , OW_mwupdnpanel, 'UIDropDownMenuTemplate')
	local text = OW_updd:CreateFontString(nil, 'BACKGROUND')
	text:SetPoint('BOTTOMLEFT', OW_updd, 'TOPLEFT', 21, 0)
	text:SetFontObject('GameFontNormalSmall')
	text:SetText(OW_NS.mwupre)
	
	function OW_updd.Initialize()
		local function Button_OnClick()
			UIDropDownMenu_SetSelectedValue(_G['owedup'], this.text)
			_G['owedup']:SetText(this.value)
		end
	  local items = {}
	  if OW_NS.macros[OW_NS.class] then
    	for spell,macro in pairs(OW_NS.macros[OW_NS.class]) do
    		items.text = spell
    		items.func = Button_OnClick
    		items.value = macro
    		items.checked = false
    		UIDropDownMenu_AddButton(items)
    	end
  	end
	  if OW_NS.macros["ALL"] then
    	for spell,macro in pairs(OW_NS.macros["ALL"]) do
    		items.text = spell
    		items.func = Button_OnClick
    		items.value = macro
    		items.checked = false
    		UIDropDownMenu_AddButton(items)
    	end
  	end
		items.text = OW_NS.donothing
		items.func = Button_OnClick
		items.value = ""
		items.checked = false
		UIDropDownMenu_AddButton(items)
  end

	OW_updd:SetScript('OnShow', Dropdown_OnShow)
	OW_updd:SetPoint('TOPLEFT', -10, -20)

  local scroll1 = CreateFrame('ScrollFrame',"owscr1",OW_mwupdnpanel,"UIPanelScrollFrameTemplate")
  scroll1:SetPoint("TOPLEFT",OW_updd,"BOTTOMLEFT",20,0)
  scroll1:SetPoint("TOPRIGHT",OW_mwupdnpanel,"TOPRIGHT",-40,0)
  scroll1:SetPoint("BOTTOMLEFT",OW_updd,"BOTTOMLEFT",0,-140)
  local edit1 = CreateFrame('EditBox',"owedup",scroll1)
	edit1:SetAutoFocus(nil)
  edit1:SetFontObject('GameFontHighlightSmall')
  edit1:SetWidth(335) 
  edit1:SetMultiLine(true)
  edit1:SetMaxLetters(255)
  scroll1:SetScrollChild(edit1)

  local OW_dndd = CreateFrame('Frame', "owcon1" , OW_mwupdnpanel, 'UIDropDownMenuTemplate')
	local text = OW_dndd:CreateFontString(nil, 'BACKGROUND')
	text:SetPoint('BOTTOMLEFT', OW_dndd, 'TOPLEFT', 21, 0)
	text:SetFontObject('GameFontNormalSmall')
	text:SetText(OW_NS.mwdnpre)
	
	function OW_dndd.Initialize()
		local function Button_OnClick()
			UIDropDownMenu_SetSelectedValue(_G['oweddn'], this.text)
			_G['oweddn']:SetText(this.value)
		end
	  local items = {}
	  if OW_NS.macros[OW_NS.class] then
    	for spell,macro in pairs(OW_NS.macros[OW_NS.class]) do
    		items.text = spell
    		items.func = Button_OnClick
    		items.value = macro
    		items.checked = false
    		UIDropDownMenu_AddButton(items)
    	end
  	end
	  if OW_NS.macros["ALL"] then
    	for spell,macro in pairs(OW_NS.macros["ALL"]) do
    		items.text = spell
    		items.func = Button_OnClick
    		items.value = macro
    		items.checked = false
    		UIDropDownMenu_AddButton(items)
    	end
  	end
		items.text = OW_NS.donothing
		items.func = Button_OnClick
		items.value = ""
		items.checked = false
		UIDropDownMenu_AddButton(items)
  end

	OW_dndd:SetScript('OnShow', Dropdown_OnShow)
	OW_dndd:SetPoint('TOPLEFT', scroll1, "BOTTOMLEFT", -20, -20)

  local scroll2 = CreateFrame('ScrollFrame',"owscr2",OW_mwupdnpanel,"UIPanelScrollFrameTemplate")
  scroll2:SetPoint("TOPLEFT",OW_dndd,"BOTTOMLEFT",20,0)
  scroll2:SetPoint("TOPRIGHT",OW_mwupdnpanel,"TOPRIGHT",-40,0)
  scroll2:SetPoint("BOTTOMLEFT",OW_dndd,"BOTTOMLEFT",0,-140)
  local edit2 = CreateFrame('EditBox',"oweddn",scroll2)
	edit2:SetAutoFocus(nil)
  edit2:SetFontObject('GameFontHighlightSmall')
  edit2:SetWidth(335) 
  edit2:SetMultiLine(true)
  edit1:SetMaxLetters(255)
  scroll2:SetScrollChild(edit2)

	local czoom = CreateFrame('CheckButton', "owzoom" , OW_optionspanel,"UICheckButtonTemplate")
	_G[czoom:GetName() .. 'Text']:SetText(OW_NS.czoom)
	czoom:SetPoint('BOTTOMLEFT', OW_optionspanel, 'BOTTOMLEFT', 5 ,5)
	czoom:SetScript("OnClick",function() OW_options['CZOOM'] = czoom:GetChecked() end)
	czoom:SetChecked(OW_options['CZOOM'])

	local shiftb = CreateFrame('CheckButton', "owshift" , OW_optionspanel,"UICheckButtonTemplate")
	_G[shiftb:GetName() .. 'Text']:SetText("Shift")
	shiftb:SetPoint('BOTTOMLEFT', czoom, 'TOPLEFT', 0 ,-5)
	shiftb:SetScript("OnClick",OW_NS.bindings)
	shiftb:SetChecked(OW_options['BSHIFT'])

	local ctrlb = CreateFrame('CheckButton', "owctrl" , OW_optionspanel,"UICheckButtonTemplate")
	_G[ctrlb:GetName() .. 'Text']:SetText("Ctrl")
	ctrlb:SetPoint('BOTTOMLEFT', shiftb, 'BOTTOMRIGHT', 30 ,0)
	ctrlb:SetScript("OnClick",OW_NS.bindings)
	ctrlb:SetChecked(OW_options['BCTRL'])

	local altb = CreateFrame('CheckButton', "owalt" , OW_optionspanel,"UICheckButtonTemplate")
	_G[altb:GetName() .. 'Text']:SetText("Alt + MouseWheel")
	altb:SetPoint('BOTTOMLEFT', ctrlb, 'BOTTOMRIGHT', 30 ,0)
	altb:SetScript("OnClick",OW_NS.bindings)
	altb:SetChecked(OW_options['BALT'])
end

function OW_NS.bindings()
  OW_options['BSHIFT'] = _G['owshift']:GetChecked()
  OW_options['BCTRL'] = _G['owctrl']:GetChecked()
  OW_options['BALT'] = _G['owalt']:GetChecked()
  ClearOverrideBindings(OWheely)
  SetOverrideBindingClick(OWheely,true,"MOUSEWHEELUP", "OW_BuffFrame","MWUP")
  SetOverrideBindingClick(OWheely,true,"MOUSEWHEELDOWN", "OW_BuffFrame","MWDN")
  if _G['owshift']:GetChecked() then
    SetOverrideBindingClick(OWheely,true,"SHIFT-MOUSEWHEELUP", "OW_BuffFrame","MWUP")
    SetOverrideBindingClick(OWheely,true,"SHIFT-MOUSEWHEELDOWN", "OW_BuffFrame","MWDN")
  end
  if _G['owctrl']:GetChecked() then
    SetOverrideBindingClick(OWheely,true,"CTRL-MOUSEWHEELUP", "OW_BuffFrame","MWUP")
    SetOverrideBindingClick(OWheely,true,"CTRL-MOUSEWHEELDOWN", "OW_BuffFrame","MWDN")
  end
  if _G['owalt']:GetChecked() then
    SetOverrideBindingClick(OWheely,true,"ALT-MOUSEWHEELUP", "OW_BuffFrame","MWUP")
    SetOverrideBindingClick(OWheely,true,"ALT-MOUSEWHEELDOWN", "OW_BuffFrame","MWDN")
  end
end
